"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("isomorphic-fetch");

var _nodeFetch = _interopRequireWildcard(require("node-fetch"));

var _bluebird = _interopRequireDefault(require("bluebird"));

_nodeFetch.default.Promise = _bluebird.default;

class Connector {
  constructor({
    debug,
    httpsAgent,
    timeout = Number(process.env.FETCH_TIMEOUT) || Number(process.env.TIMEOUT) || 1000
  }) {
    this.debug = debug;

    this.log = msg => this.debug('%j', msg);

    this.httpsAgent = httpsAgent;
    this.timeout = timeout;
  }

  fetch(url, request, responseType = 'json') {
    this.debug('%j', {
      url,
      responseType,
      agent: this.httpsAgent,
      timeout: this.timeout,
      ...request
    });
    return fetch(url, {
      agent: this.httpsAgent,
      timeout: this.timeout,
      ...request
    }).tap(this.log).then(res => res.ok ? res : _bluebird.default.reject(new _nodeFetch.FetchError(`HTTP Error Response: ${res.status} ${res.statusText}`, 'status-code'))).then(res => res[responseType]()).tap(this.log).tapCatch(this.log);
  }

}

var _default = Connector;
exports.default = _default;